<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfErrorServiceOrderItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfErrorServiceOrderItem extends AbstractStructArrayBase
{
    /**
     * The ErrorServiceOrderItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ErrorServiceOrderItem[]
     */
    public $ErrorServiceOrderItem;
    /**
     * Constructor method for ArrayOfErrorServiceOrderItem
     * @uses ArrayOfErrorServiceOrderItem::setErrorServiceOrderItem()
     * @param \StructType\ErrorServiceOrderItem[] $errorServiceOrderItem
     */
    public function __construct(array $errorServiceOrderItem = array())
    {
        $this
            ->setErrorServiceOrderItem($errorServiceOrderItem);
    }
    /**
     * Get ErrorServiceOrderItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ErrorServiceOrderItem[]|null
     */
    public function getErrorServiceOrderItem()
    {
        return isset($this->ErrorServiceOrderItem) ? $this->ErrorServiceOrderItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setErrorServiceOrderItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErrorServiceOrderItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErrorServiceOrderItemForArrayConstraintsFromSetErrorServiceOrderItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfErrorServiceOrderItemErrorServiceOrderItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfErrorServiceOrderItemErrorServiceOrderItemItem instanceof \StructType\ErrorServiceOrderItem) {
                $invalidValues[] = is_object($arrayOfErrorServiceOrderItemErrorServiceOrderItemItem) ? get_class($arrayOfErrorServiceOrderItemErrorServiceOrderItemItem) : sprintf('%s(%s)', gettype($arrayOfErrorServiceOrderItemErrorServiceOrderItemItem), var_export($arrayOfErrorServiceOrderItemErrorServiceOrderItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ErrorServiceOrderItem property can only contain items of type \StructType\ErrorServiceOrderItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ErrorServiceOrderItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorServiceOrderItem[] $errorServiceOrderItem
     * @return \ArrayType\ArrayOfErrorServiceOrderItem
     */
    public function setErrorServiceOrderItem(array $errorServiceOrderItem = array())
    {
        // validation for constraint: array
        if ('' !== ($errorServiceOrderItemArrayErrorMessage = self::validateErrorServiceOrderItemForArrayConstraintsFromSetErrorServiceOrderItem($errorServiceOrderItem))) {
            throw new \InvalidArgumentException($errorServiceOrderItemArrayErrorMessage, __LINE__);
        }
        if (is_null($errorServiceOrderItem) || (is_array($errorServiceOrderItem) && empty($errorServiceOrderItem))) {
            unset($this->ErrorServiceOrderItem);
        } else {
            $this->ErrorServiceOrderItem = $errorServiceOrderItem;
        }
        return $this;
    }
    /**
     * Add item to ErrorServiceOrderItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorServiceOrderItem $item
     * @return \ArrayType\ArrayOfErrorServiceOrderItem
     */
    public function addToErrorServiceOrderItem(\StructType\ErrorServiceOrderItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ErrorServiceOrderItem) {
            throw new \InvalidArgumentException(sprintf('The ErrorServiceOrderItem property can only contain items of type \StructType\ErrorServiceOrderItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ErrorServiceOrderItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ErrorServiceOrderItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ErrorServiceOrderItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ErrorServiceOrderItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ErrorServiceOrderItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ErrorServiceOrderItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ErrorServiceOrderItem
     */
    public function getAttributeName()
    {
        return 'ErrorServiceOrderItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfErrorServiceOrderItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
