<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReturnItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfReturnItem extends AbstractStructArrayBase
{
    /**
     * The ReturnItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReturnItem[]
     */
    public $ReturnItem;
    /**
     * Constructor method for ArrayOfReturnItem
     * @uses ArrayOfReturnItem::setReturnItem()
     * @param \StructType\ReturnItem[] $returnItem
     */
    public function __construct(array $returnItem = array())
    {
        $this
            ->setReturnItem($returnItem);
    }
    /**
     * Get ReturnItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReturnItem[]|null
     */
    public function getReturnItem()
    {
        return isset($this->ReturnItem) ? $this->ReturnItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setReturnItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReturnItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReturnItemForArrayConstraintsFromSetReturnItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfReturnItemReturnItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfReturnItemReturnItemItem instanceof \StructType\ReturnItem) {
                $invalidValues[] = is_object($arrayOfReturnItemReturnItemItem) ? get_class($arrayOfReturnItemReturnItemItem) : sprintf('%s(%s)', gettype($arrayOfReturnItemReturnItemItem), var_export($arrayOfReturnItemReturnItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReturnItem property can only contain items of type \StructType\ReturnItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReturnItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ReturnItem[] $returnItem
     * @return \ArrayType\ArrayOfReturnItem
     */
    public function setReturnItem(array $returnItem = array())
    {
        // validation for constraint: array
        if ('' !== ($returnItemArrayErrorMessage = self::validateReturnItemForArrayConstraintsFromSetReturnItem($returnItem))) {
            throw new \InvalidArgumentException($returnItemArrayErrorMessage, __LINE__);
        }
        if (is_null($returnItem) || (is_array($returnItem) && empty($returnItem))) {
            unset($this->ReturnItem);
        } else {
            $this->ReturnItem = $returnItem;
        }
        return $this;
    }
    /**
     * Add item to ReturnItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ReturnItem $item
     * @return \ArrayType\ArrayOfReturnItem
     */
    public function addToReturnItem(\StructType\ReturnItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReturnItem) {
            throw new \InvalidArgumentException(sprintf('The ReturnItem property can only contain items of type \StructType\ReturnItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReturnItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ReturnItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ReturnItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ReturnItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ReturnItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ReturnItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReturnItem
     */
    public function getAttributeName()
    {
        return 'ReturnItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfReturnItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
