<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetCategories' => '\\StructType\\GetCategories',
            'GetCategoriesResponse' => '\\StructType\\GetCategoriesResponse',
            'CategoryInfoResponseOfCategoryInfo' => '\\StructType\\CategoryInfoResponseOfCategoryInfo',
            'MethodResponseOfCategoryInfo' => '\\StructType\\MethodResponseOfCategoryInfo',
            'MethodResponse' => '\\StructType\\MethodResponse',
            'CategoryInfo' => '\\StructType\\CategoryInfo',
            'ArrayOfCategoryInfo' => '\\ArrayType\\ArrayOfCategoryInfo',
            'AuthenticationHeader' => '\\StructType\\AuthenticationHeader',
            'GetArticlesByID' => '\\StructType\\GetArticlesByID',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'GetArticlesByIDResponse' => '\\StructType\\GetArticlesByIDResponse',
            'ArticlesInfoResponseOfArticleInfo' => '\\StructType\\ArticlesInfoResponseOfArticleInfo',
            'MethodResponseOfArticleInfo' => '\\StructType\\MethodResponseOfArticleInfo',
            'ArticleInfo' => '\\StructType\\ArticleInfo',
            'Info' => '\\StructType\\Info',
            'ArrayOfQuantityInfo' => '\\ArrayType\\ArrayOfQuantityInfo',
            'QuantityInfo' => '\\StructType\\QuantityInfo',
            'ArrayOfPropInfo' => '\\ArrayType\\ArrayOfPropInfo',
            'PropInfo' => '\\StructType\\PropInfo',
            'PriceInfo' => '\\StructType\\PriceInfo',
            'BatchInfo' => '\\StructType\\BatchInfo',
            'ArrayOfBatchInfo' => '\\ArrayType\\ArrayOfBatchInfo',
            'ArrayOfArticleInfo' => '\\ArrayType\\ArrayOfArticleInfo',
            'GetArticlesByDate' => '\\StructType\\GetArticlesByDate',
            'GetArticlesByDateResponse' => '\\StructType\\GetArticlesByDateResponse',
            'CreateContragent' => '\\StructType\\CreateContragent',
            'ContragentInfo' => '\\StructType\\ContragentInfo',
            'CreateContragentResponse' => '\\StructType\\CreateContragentResponse',
            'ContragentResponse' => '\\StructType\\ContragentResponse',
            'CreateOrder' => '\\StructType\\CreateOrder',
            'DeliveryInfo' => '\\StructType\\DeliveryInfo',
            'ArrayOfOrderItem' => '\\ArrayType\\ArrayOfOrderItem',
            'OrderItem' => '\\StructType\\OrderItem',
            'SmetkaItem' => '\\StructType\\SmetkaItem',
            'CreateOrderResponse' => '\\StructType\\CreateOrderResponse',
            'OrderResponse' => '\\StructType\\OrderResponse',
            'ArrayOfErrorServiceOrderItem' => '\\ArrayType\\ArrayOfErrorServiceOrderItem',
            'ErrorServiceOrderItem' => '\\StructType\\ErrorServiceOrderItem',
            'CreateReturn' => '\\StructType\\CreateReturn',
            'ArrayOfReturnItem' => '\\ArrayType\\ArrayOfReturnItem',
            'ReturnItem' => '\\StructType\\ReturnItem',
            'CreateReturnResponse' => '\\StructType\\CreateReturnResponse',
            'EditOrder' => '\\StructType\\EditOrder',
            'EditOrderResponse' => '\\StructType\\EditOrderResponse',
        );
    }
}
