<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ArticleInfo StructType
 * @subpackage Structs
 */
class ArticleInfo extends Info
{
    /**
     * The BatchList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfBatchInfo
     */
    public $BatchList;
    /**
     * The CategoryID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CategoryID;
    /**
     * The BrandName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $BrandName;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Group
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Group;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The NameEN
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NameEN;
    /**
     * The DescriptionEN
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DescriptionEN;
    /**
     * The Picture1Url
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Picture1Url;
    /**
     * The Picture2Url
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Picture2Url;
    /**
     * The Picture3Url
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Picture3Url;
    /**
     * The Thumbnail1Url
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Thumbnail1Url;
    /**
     * The Thumbnail2Url
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Thumbnail2Url;
    /**
     * The Thumbnail3Url
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Thumbnail3Url;
    /**
     * Constructor method for ArticleInfo
     * @uses ArticleInfo::setBatchList()
     * @uses ArticleInfo::setCategoryID()
     * @uses ArticleInfo::setBrandName()
     * @uses ArticleInfo::setName()
     * @uses ArticleInfo::setGroup()
     * @uses ArticleInfo::setDescription()
     * @uses ArticleInfo::setNameEN()
     * @uses ArticleInfo::setDescriptionEN()
     * @uses ArticleInfo::setPicture1Url()
     * @uses ArticleInfo::setPicture2Url()
     * @uses ArticleInfo::setPicture3Url()
     * @uses ArticleInfo::setThumbnail1Url()
     * @uses ArticleInfo::setThumbnail2Url()
     * @uses ArticleInfo::setThumbnail3Url()
     * @param \ArrayType\ArrayOfBatchInfo $batchList
     * @param string $categoryID
     * @param string $brandName
     * @param string $name
     * @param string $group
     * @param string $description
     * @param string $nameEN
     * @param string $descriptionEN
     * @param string $picture1Url
     * @param string $picture2Url
     * @param string $picture3Url
     * @param string $thumbnail1Url
     * @param string $thumbnail2Url
     * @param string $thumbnail3Url
     */
    public function __construct(\ArrayType\ArrayOfBatchInfo $batchList = null, $categoryID = null, $brandName = null, $name = null, $group = null, $description = null, $nameEN = null, $descriptionEN = null, $picture1Url = null, $picture2Url = null, $picture3Url = null, $thumbnail1Url = null, $thumbnail2Url = null, $thumbnail3Url = null)
    {
        $this
            ->setBatchList($batchList)
            ->setCategoryID($categoryID)
            ->setBrandName($brandName)
            ->setName($name)
            ->setGroup($group)
            ->setDescription($description)
            ->setNameEN($nameEN)
            ->setDescriptionEN($descriptionEN)
            ->setPicture1Url($picture1Url)
            ->setPicture2Url($picture2Url)
            ->setPicture3Url($picture3Url)
            ->setThumbnail1Url($thumbnail1Url)
            ->setThumbnail2Url($thumbnail2Url)
            ->setThumbnail3Url($thumbnail3Url);
    }
    /**
     * Get BatchList value
     * @return \ArrayType\ArrayOfBatchInfo|null
     */
    public function getBatchList()
    {
        return $this->BatchList;
    }
    /**
     * Set BatchList value
     * @param \ArrayType\ArrayOfBatchInfo $batchList
     * @return \StructType\ArticleInfo
     */
    public function setBatchList(\ArrayType\ArrayOfBatchInfo $batchList = null)
    {
        $this->BatchList = $batchList;
        return $this;
    }
    /**
     * Get CategoryID value
     * @return string|null
     */
    public function getCategoryID()
    {
        return $this->CategoryID;
    }
    /**
     * Set CategoryID value
     * @param string $categoryID
     * @return \StructType\ArticleInfo
     */
    public function setCategoryID($categoryID = null)
    {
        // validation for constraint: string
        if (!is_null($categoryID) && !is_string($categoryID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($categoryID, true), gettype($categoryID)), __LINE__);
        }
        $this->CategoryID = $categoryID;
        return $this;
    }
    /**
     * Get BrandName value
     * @return string|null
     */
    public function getBrandName()
    {
        return $this->BrandName;
    }
    /**
     * Set BrandName value
     * @param string $brandName
     * @return \StructType\ArticleInfo
     */
    public function setBrandName($brandName = null)
    {
        // validation for constraint: string
        if (!is_null($brandName) && !is_string($brandName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($brandName, true), gettype($brandName)), __LINE__);
        }
        $this->BrandName = $brandName;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\ArticleInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Group value
     * @return string|null
     */
    public function getGroup()
    {
        return $this->Group;
    }
    /**
     * Set Group value
     * @param string $group
     * @return \StructType\ArticleInfo
     */
    public function setGroup($group = null)
    {
        // validation for constraint: string
        if (!is_null($group) && !is_string($group)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($group, true), gettype($group)), __LINE__);
        }
        $this->Group = $group;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\ArticleInfo
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get NameEN value
     * @return string|null
     */
    public function getNameEN()
    {
        return $this->NameEN;
    }
    /**
     * Set NameEN value
     * @param string $nameEN
     * @return \StructType\ArticleInfo
     */
    public function setNameEN($nameEN = null)
    {
        // validation for constraint: string
        if (!is_null($nameEN) && !is_string($nameEN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nameEN, true), gettype($nameEN)), __LINE__);
        }
        $this->NameEN = $nameEN;
        return $this;
    }
    /**
     * Get DescriptionEN value
     * @return string|null
     */
    public function getDescriptionEN()
    {
        return $this->DescriptionEN;
    }
    /**
     * Set DescriptionEN value
     * @param string $descriptionEN
     * @return \StructType\ArticleInfo
     */
    public function setDescriptionEN($descriptionEN = null)
    {
        // validation for constraint: string
        if (!is_null($descriptionEN) && !is_string($descriptionEN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descriptionEN, true), gettype($descriptionEN)), __LINE__);
        }
        $this->DescriptionEN = $descriptionEN;
        return $this;
    }
    /**
     * Get Picture1Url value
     * @return string|null
     */
    public function getPicture1Url()
    {
        return $this->Picture1Url;
    }
    /**
     * Set Picture1Url value
     * @param string $picture1Url
     * @return \StructType\ArticleInfo
     */
    public function setPicture1Url($picture1Url = null)
    {
        // validation for constraint: string
        if (!is_null($picture1Url) && !is_string($picture1Url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($picture1Url, true), gettype($picture1Url)), __LINE__);
        }
        $this->Picture1Url = $picture1Url;
        return $this;
    }
    /**
     * Get Picture2Url value
     * @return string|null
     */
    public function getPicture2Url()
    {
        return $this->Picture2Url;
    }
    /**
     * Set Picture2Url value
     * @param string $picture2Url
     * @return \StructType\ArticleInfo
     */
    public function setPicture2Url($picture2Url = null)
    {
        // validation for constraint: string
        if (!is_null($picture2Url) && !is_string($picture2Url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($picture2Url, true), gettype($picture2Url)), __LINE__);
        }
        $this->Picture2Url = $picture2Url;
        return $this;
    }
    /**
     * Get Picture3Url value
     * @return string|null
     */
    public function getPicture3Url()
    {
        return $this->Picture3Url;
    }
    /**
     * Set Picture3Url value
     * @param string $picture3Url
     * @return \StructType\ArticleInfo
     */
    public function setPicture3Url($picture3Url = null)
    {
        // validation for constraint: string
        if (!is_null($picture3Url) && !is_string($picture3Url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($picture3Url, true), gettype($picture3Url)), __LINE__);
        }
        $this->Picture3Url = $picture3Url;
        return $this;
    }
    /**
     * Get Thumbnail1Url value
     * @return string|null
     */
    public function getThumbnail1Url()
    {
        return $this->Thumbnail1Url;
    }
    /**
     * Set Thumbnail1Url value
     * @param string $thumbnail1Url
     * @return \StructType\ArticleInfo
     */
    public function setThumbnail1Url($thumbnail1Url = null)
    {
        // validation for constraint: string
        if (!is_null($thumbnail1Url) && !is_string($thumbnail1Url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($thumbnail1Url, true), gettype($thumbnail1Url)), __LINE__);
        }
        $this->Thumbnail1Url = $thumbnail1Url;
        return $this;
    }
    /**
     * Get Thumbnail2Url value
     * @return string|null
     */
    public function getThumbnail2Url()
    {
        return $this->Thumbnail2Url;
    }
    /**
     * Set Thumbnail2Url value
     * @param string $thumbnail2Url
     * @return \StructType\ArticleInfo
     */
    public function setThumbnail2Url($thumbnail2Url = null)
    {
        // validation for constraint: string
        if (!is_null($thumbnail2Url) && !is_string($thumbnail2Url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($thumbnail2Url, true), gettype($thumbnail2Url)), __LINE__);
        }
        $this->Thumbnail2Url = $thumbnail2Url;
        return $this;
    }
    /**
     * Get Thumbnail3Url value
     * @return string|null
     */
    public function getThumbnail3Url()
    {
        return $this->Thumbnail3Url;
    }
    /**
     * Set Thumbnail3Url value
     * @param string $thumbnail3Url
     * @return \StructType\ArticleInfo
     */
    public function setThumbnail3Url($thumbnail3Url = null)
    {
        // validation for constraint: string
        if (!is_null($thumbnail3Url) && !is_string($thumbnail3Url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($thumbnail3Url, true), gettype($thumbnail3Url)), __LINE__);
        }
        $this->Thumbnail3Url = $thumbnail3Url;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ArticleInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
