<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContragentInfo StructType
 * @subpackage Structs
 */
class ContragentInfo extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Country
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Country;
    /**
     * The Post
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Post;
    /**
     * The City
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $City;
    /**
     * The Address
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Address;
    /**
     * The Phone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Phone;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Email;
    /**
     * The Bulstat
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Bulstat;
    /**
     * The MOL
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MOL;
    /**
     * The VAT
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $VAT;
    /**
     * Constructor method for ContragentInfo
     * @uses ContragentInfo::setName()
     * @uses ContragentInfo::setCountry()
     * @uses ContragentInfo::setPost()
     * @uses ContragentInfo::setCity()
     * @uses ContragentInfo::setAddress()
     * @uses ContragentInfo::setPhone()
     * @uses ContragentInfo::setEmail()
     * @uses ContragentInfo::setBulstat()
     * @uses ContragentInfo::setMOL()
     * @uses ContragentInfo::setVAT()
     * @param string $name
     * @param string $country
     * @param string $post
     * @param string $city
     * @param string $address
     * @param string $phone
     * @param string $email
     * @param string $bulstat
     * @param string $mOL
     * @param string $vAT
     */
    public function __construct($name = null, $country = null, $post = null, $city = null, $address = null, $phone = null, $email = null, $bulstat = null, $mOL = null, $vAT = null)
    {
        $this
            ->setName($name)
            ->setCountry($country)
            ->setPost($post)
            ->setCity($city)
            ->setAddress($address)
            ->setPhone($phone)
            ->setEmail($email)
            ->setBulstat($bulstat)
            ->setMOL($mOL)
            ->setVAT($vAT);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\ContragentInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->Country;
    }
    /**
     * Set Country value
     * @param string $country
     * @return \StructType\ContragentInfo
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country, true), gettype($country)), __LINE__);
        }
        $this->Country = $country;
        return $this;
    }
    /**
     * Get Post value
     * @return string|null
     */
    public function getPost()
    {
        return $this->Post;
    }
    /**
     * Set Post value
     * @param string $post
     * @return \StructType\ContragentInfo
     */
    public function setPost($post = null)
    {
        // validation for constraint: string
        if (!is_null($post) && !is_string($post)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($post, true), gettype($post)), __LINE__);
        }
        $this->Post = $post;
        return $this;
    }
    /**
     * Get City value
     * @return string|null
     */
    public function getCity()
    {
        return $this->City;
    }
    /**
     * Set City value
     * @param string $city
     * @return \StructType\ContragentInfo
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->City = $city;
        return $this;
    }
    /**
     * Get Address value
     * @return string|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param string $address
     * @return \StructType\ContragentInfo
     */
    public function setAddress($address = null)
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address, true), gettype($address)), __LINE__);
        }
        $this->Address = $address;
        return $this;
    }
    /**
     * Get Phone value
     * @return string|null
     */
    public function getPhone()
    {
        return $this->Phone;
    }
    /**
     * Set Phone value
     * @param string $phone
     * @return \StructType\ContragentInfo
     */
    public function setPhone($phone = null)
    {
        // validation for constraint: string
        if (!is_null($phone) && !is_string($phone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($phone, true), gettype($phone)), __LINE__);
        }
        $this->Phone = $phone;
        return $this;
    }
    /**
     * Get Email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param string $email
     * @return \StructType\ContragentInfo
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($email, true), gettype($email)), __LINE__);
        }
        $this->Email = $email;
        return $this;
    }
    /**
     * Get Bulstat value
     * @return string|null
     */
    public function getBulstat()
    {
        return $this->Bulstat;
    }
    /**
     * Set Bulstat value
     * @param string $bulstat
     * @return \StructType\ContragentInfo
     */
    public function setBulstat($bulstat = null)
    {
        // validation for constraint: string
        if (!is_null($bulstat) && !is_string($bulstat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bulstat, true), gettype($bulstat)), __LINE__);
        }
        $this->Bulstat = $bulstat;
        return $this;
    }
    /**
     * Get MOL value
     * @return string|null
     */
    public function getMOL()
    {
        return $this->MOL;
    }
    /**
     * Set MOL value
     * @param string $mOL
     * @return \StructType\ContragentInfo
     */
    public function setMOL($mOL = null)
    {
        // validation for constraint: string
        if (!is_null($mOL) && !is_string($mOL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mOL, true), gettype($mOL)), __LINE__);
        }
        $this->MOL = $mOL;
        return $this;
    }
    /**
     * Get VAT value
     * @return string|null
     */
    public function getVAT()
    {
        return $this->VAT;
    }
    /**
     * Set VAT value
     * @param string $vAT
     * @return \StructType\ContragentInfo
     */
    public function setVAT($vAT = null)
    {
        // validation for constraint: string
        if (!is_null($vAT) && !is_string($vAT)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vAT, true), gettype($vAT)), __LINE__);
        }
        $this->VAT = $vAT;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ContragentInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
