<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderItem StructType
 * @subpackage Structs
 */
class OrderItem extends SmetkaItem
{
    /**
     * The EndPriceWithVAT
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PriceInfo
     */
    public $EndPriceWithVAT;
    /**
     * Constructor method for OrderItem
     * @uses OrderItem::setEndPriceWithVAT()
     * @param \StructType\PriceInfo $endPriceWithVAT
     */
    public function __construct(\StructType\PriceInfo $endPriceWithVAT = null)
    {
        $this
            ->setEndPriceWithVAT($endPriceWithVAT);
    }
    /**
     * Get EndPriceWithVAT value
     * @return \StructType\PriceInfo|null
     */
    public function getEndPriceWithVAT()
    {
        return $this->EndPriceWithVAT;
    }
    /**
     * Set EndPriceWithVAT value
     * @param \StructType\PriceInfo $endPriceWithVAT
     * @return \StructType\OrderItem
     */
    public function setEndPriceWithVAT(\StructType\PriceInfo $endPriceWithVAT = null)
    {
        $this->EndPriceWithVAT = $endPriceWithVAT;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OrderItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
